//-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
// Click Push - By Destiny
//-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
   if(!$RTB::RTBR_ServerControl_Hook)
      exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");
   RTB_registerPref("Click Push Status","Gameplay","$ClickPush::Status","bool","Script_ClickPush",1,0,0);
   RTB_registerPref("Click Push Amount","Gameplay","$ClickPush::Amount","int 0 300","Script_ClickPush",8,0,0);
}
else
{
   $ClickPush::Amount = 8;
}
package ClickPush
{
   function armor::onTrigger(%this, %obj, %triggerNum, %val)
   {
      Parent::onTrigger(%this,%obj,%triggerNum,%val);
      %client = %obj.client;
      %target = containerRayCast(%client.player.getEyePoint(), vectorAdd(vectorScale(vectorNormalize(%client.player.getEyeVector()), 2), %client.player.getEyePoint()), $typeMasks::playerObjectType);
      if(!isObject(%target) || %target $= %obj || %obj.getObjectMount() $= %target)
      {
         return;
      }
      if($ClickPush::Status != 1)
      {
         return;
      }
      %target.setVelocity(vectorAdd(%target.getVelocity(),vectorScale(%obj.client.player.getEyeVector(),$ClickPush::Amount)));
   }
};
activatepackage(ClickPush);